Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCustom.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCustom.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCustom.pm	(revision 34921)
@@ -3423,10 +8309,10 @@
         Name => 'ShutterReleaseButtonAE-L',
         Mask => 0x02,
-        PrintConv => { 0x00 => 'Off', 0x02 => 'On' },
+        PrintConv => \%offOn,
     },
     17.6 => { # CSf7
         Name => 'ReleaseButtonToUseDial',
         Mask => 0x01,
-        PrintConv => { 0x00 => 'No', 0x01 => 'Yes' },
+        PrintConv => \%noYes,
     },
     18.1 => { # CSc2
@@ -3435,14 +8321,14 @@
         PrintConvColumns => 2,
         PrintConv => {
-            0x00 => '4 s',
-            0x10 => '6 s', # default
-            0x20 => '8 s',
-            0x30 => '16 s',
-            0x40 => '30 s',
-            0x50 => '1 min',
-            0x60 => '5 min',
-            0x70 => '10 min',
-            0x80 => '30 min',
-            0x90 => 'No Limit',
+            0 => '4 s',
+            1 => '6 s', # default
+            2 => '8 s',
+            3 => '16 s',
+            4 => '30 s',
+            5 => '1 min',
+            6 => '5 min',
+            7 => '10 min',
+            8 => '30 min',
+            9 => 'No Limit',
         },
     },
@@ -3451,8 +8337,8 @@
         Mask => 0x03,
         PrintConv => {
-            0x00 => '1 min',
-            0x01 => '5 min',
-            0x02 => '10 min',
-            0x03 => '15 min',
+            0 => '1 min',
+            1 => '5 min',
+            2 => '10 min',
+            3 => '15 min',
         },
     },
@@ -3461,8 +8347,8 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => '2 s',
-            0x40 => '5 s',
-            0x80 => '10 s', # default
-            0xc0 => '20 s',
+            0 => '2 s',
+            1 => '5 s',
+            2 => '10 s', # default
+            3 => '20 s',
         },
     },
@@ -3471,8 +8357,8 @@
         Mask => 0x30,
         PrintConv => {
-            0x00 => '0.5 s',
-            0x10 => '1 s',
-            0x20 => '2 s', # default
-            0x30 => '3 s',
+            0 => '0.5 s',
+            1 => '1 s',
+            2 => '2 s', # default
+            3 => '3 s',
         },
     },
@@ -3484,11 +8370,11 @@
         Name => 'ImageReviewTime',
         Mask => 0xe0,
-        PrintConv => { # (NC)
-            0x00 => '4 s',
-            0x20 => '10 s', # default
-            0x40 => '20 s',
-            0x60 => '1 min',
-            0x80 => '5 min',
-            0xa0 => '10 min',
+        PrintConv => { #(NC)
+            0 => '4 s',
+            1 => '10 s', # default
+            2 => '20 s',
+            3 => '1 min',
+            4 => '5 min',
+            5 => '10 min',
         },
     },
@@ -3496,11 +8382,11 @@
         Name => 'LiveViewMonitorOffTime',
         Mask => 0x1c,
-        PrintConv => { # (NC)
-            0x00 => '4 s',
-            0x04 => '10 s', # default
-            0x08 => '20 s',
-            0x0c => '1 min',
-            0x10 => '5 min',
-            0x14 => '10 min',
+        PrintConv => { #(NC)
+            0 => '4 s',
+            1 => '10 s', # default
+            2 => '20 s',
+            3 => '1 min',
+            4 => '5 min',
+            5 => '10 min',
         },
     },
@@ -3509,10 +8395,10 @@
         Mask => 0xe0,
         PrintConv => {
-            0x00 => '4 s',
-            0x20 => '10 s', # default
-            0x40 => '20 s',
-            0x60 => '1 min',
-            0x80 => '5 min',
-            0xa0 => '10 min',
+            0 => '4 s',
+            1 => '10 s', # default
+            2 => '20 s',
+            3 => '1 min',
+            4 => '5 min',
+            5 => '10 min',
         },
     },
@@ -3520,11 +8406,11 @@
         Name => 'ShootingInfoMonitorOffTime',
         Mask => 0x1c,
-        PrintConv => { # (NC)
-            0x00 => '4 s',
-            0x04 => '10 s', # default
-            0x08 => '20 s',
-            0x0c => '1 min',
-            0x10 => '5 min',
-            0x14 => '10 min',
+        PrintConv => { #(NC)
+            0 => '4 s',
+            1 => '10 s', # default
+            2 => '20 s',
+            3 => '1 min',
+            4 => '5 min',
+            5 => '10 min',
         },
     },
@@ -3533,13 +8419,13 @@
         Mask => 0xf0,
         PrintConv => {
-            0x00 => '1/320 s (auto FP)',
-            0x10 => '1/250 s (auto FP)',
-            0x20 => '1/250 s',
-            0x30 => '1/200 s',
-            0x40 => '1/160 s',
-            0x50 => '1/125 s',
-            0x60 => '1/100 s',
-            0x70 => '1/80 s',
-            0x80 => '1/60 s',
+            0 => '1/320 s (auto FP)',
+            1 => '1/250 s (auto FP)',
+            2 => '1/250 s',
+            3 => '1/200 s',
+            4 => '1/160 s',
+            5 => '1/125 s',
+            6 => '1/100 s',
+            7 => '1/80 s',
+            8 => '1/60 s',
        },
     },
@@ -3549,16 +8435,16 @@
         PrintConvColumns => 2,
         PrintConv => {
-            0x00 => '1/60 s',
-            0x01 => '1/30 s',
-            0x02 => '1/15 s',
-            0x03 => '1/8 s',
-            0x04 => '1/4 s',
-            0x05 => '1/2 s',
-            0x06 => '1 s',
-            0x07 => '2 s',
-            0x08 => '4 s',
-            0x09 => '8 s',
-            0x0a => '15 s',
-            0x0b => '30 s',
+            0 => '1/60 s',
+            1 => '1/30 s',
+            2 => '1/15 s',
+            3 => '1/8 s',
+            4 => '1/4 s',
+            5 => '1/2 s',
+            6 => '1 s',
+            7 => '2 s',
+            8 => '4 s',
+            9 => '8 s',
+            10 => '15 s',
+            11 => '30 s',
         },
     },
@@ -3566,15 +8452,15 @@
         Name => 'FlashControlBuilt-in',
         Mask => 0xc0,
-        RawConv => '$$self{FlashControlBuiltin} = $val & 0xc0',
-        PrintConv => {
-            0x00 => 'TTL',
-            0x40 => 'Manual',
-            0x80 => 'Repeating Flash',
-            0xc0 => 'Commander Mode',
+        RawConv => '$$self{FlashControlBuiltin} = $val',
+        PrintConv => {
+            0 => 'TTL',
+            1 => 'Manual',
+            2 => 'Repeating Flash',
+            3 => 'Commander Mode',
         },
     },
     23.2 => { # CSe3-b
         Name => 'ManualFlashOutput',
-        Condition => '$$self{FlashControlBuiltin} == 0x40',
+        Condition => '$$self{FlashControlBuiltin} == 1',
         Mask => 0x1f,
         ValueConv => '2 ** (-$val/3)',
@@ -3588,8 +8474,8 @@
     24.1 => { # CSe3-ca
         Name => 'RepeatingFlashOutput',
-        Condition => '$$self{FlashControlBuiltin} == 0x80',
+        Condition => '$$self{FlashControlBuiltin} == 2',
         Mask => 0x70,
-        ValueConv => '2 ** (-($val>>4)-2)',
-        ValueConvInv => '$val > 0 ? int(-log($val)/log(2)-2+0.5)<<4 : 0',
+        ValueConv => '2 ** (-$val-2)',
+        ValueConvInv => '$val > 0 ? int(-log($val)/log(2)-2+0.5) : 0',
         PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
         PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
@@ -3597,5 +8483,5 @@
     24.2 => { # CSe3-cb
         Name => 'RepeatingFlashCount',
-        Condition => '$$self{FlashControlBuiltin} == 0x80',
+        Condition => '$$self{FlashControlBuiltin} == 2',
         Mask => 0x0f,
         ValueConv => '$val < 10 ? $val + 1 : 5 * ($val - 7)',
@@ -3604,8 +8490,8 @@
     25.1 => { # CSe3-cc (NC)
         Name => 'RepeatingFlashRate',
-        Condition => '$$self{FlashControlBuiltin} == 0x80',
+        Condition => '$$self{FlashControlBuiltin} == 2',
         Mask => 0xf0,
-        ValueConv => 'my $v=($val>>4); $v < 10 ? $v + 1 : 10 * ($v - 8)',
-        ValueConvInv => 'int(($val <= 10 ? $val - 1 : $val / 10 + 8) + 0.5) << 4',
+        ValueConv => '$val < 10 ? $val + 1 : 10 * ($val - 8)',
+        ValueConvInv => 'int(($val <= 10 ? $val - 1 : $val / 10 + 8) + 0.5)',
         PrintConv => '"$val Hz"',
         PrintConvInv => '$val=~/(\d+)/; $1 || 0',
@@ -3613,5 +8499,5 @@
     26.1 => { # CSe3-da
         Name => 'CommanderInternalTTLCompBuiltin',
-        Condition => '$$self{FlashControlBuiltin} == 0xc0',
+        Condition => '$$self{FlashControlBuiltin} == 3',
         Mask => 0x1f,
         ValueConv => '($val - 9) / 3',
@@ -3622,5 +8508,5 @@
     27.1 => { # CSe3-db
         Name => 'CommanderInternalTTLCompGroupA',
-        Condition => '$$self{FlashControlBuiltin} == 0xc0',
+        Condition => '$$self{FlashControlBuiltin} == 3',
         Mask => 0x1f,
         ValueConv => '($val - 9) / 3',
@@ -3631,5 +8517,5 @@
     28.1 => { # CSe3-dc
         Name => 'CommanderInternalTTLCompGroupB',
-        Condition => '$$self{FlashControlBuiltin} == 0xc0',
+        Condition => '$$self{FlashControlBuiltin} == 3',
         Mask => 0x1f,
         ValueConv => '($val - 9) / 3',
@@ -3641,13 +8527,10 @@
         Name => 'FlashWarning',
         Mask => 0x80,
-        PrintConv => {
-            0x00 => 'On',
-            0x80 => 'Off',
-        },
+        PrintConv => \%onOff,
     },
     30.2 => { # CSe4
         Name => 'ModelingFlash',
         Mask => 0x20,
-        PrintConv => { 0x00 => 'On', 0x20 => 'Off' },
+        PrintConv => \%onOff,
     },
     34.1 => { # CSa8-b
@@ -3655,8 +8538,8 @@
         Mask => 0x60,
         PrintConv => {
-            0x00 => 'Face-Priority',
-            0x20 => 'NormalArea',
-            0x40 => 'WideArea',
-            0x60 => 'SubjectTracking',
+            0 => 'Face-Priority',
+            1 => 'NormalArea',
+            2 => 'WideArea',
+            3 => 'SubjectTracking',
         },
     },
@@ -3665,6 +8548,6 @@
         Mask => 0x02,
         PrintConv => {
-            0x00 => 'AF-C',
-            0x02 => 'AF-F',
+            0 => 'AF-C',
+            1 => 'AF-F',
         },
     },
